#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

string to_string(__int128 x) {
    return to_string((int64_t) x);
}

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

const int dx[8] = {-1, -1, 0, 1, 1, 1, 0, -1};
const int dy[8] = {0, 1, 1, 1, 0, -1, -1, -1};

int inv(int x) {
    return (x + 4) % 8;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m));
    for (auto &x : a) {
        for (auto &y : x) {
            cin >> y;
            --y;
        }
    }

    vector<vector<int>> cntN(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int dir = 0; dir < 8; dir++) {
                int ni = i + dx[dir];
                int nj = j + dy[dir];
                if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                    cntN[i][j]++;
                }
            }
        }
    }

    vector<vector<bool>> good(n, vector<bool> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int cnt = 0;
            for (int dir = 0; dir < 8; dir++) {
                int ni = i + dx[dir];
                int nj = j + dy[dir];
                if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                    cnt += a[ni][nj] == inv(dir);
                }
            }
            good[i][j] = (cnt == cntN[i][j]);
        }
    }

    vector<vector<int>> pref(n + 1, vector<int> (m + 1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            pref[i + 1][j + 1] = pref[i][j + 1] + pref[i + 1][j] - pref[i][j] + good[i][j];
        }
    }

    auto getPref = [&] (int x1, int y1, int x2, int y2) {
        ++x2, ++y2;
        return pref[x2][y2] - pref[x2][y1] - pref[x1][y2] + pref[x1][y1];
    };

    vector<vector<int>> horUp(n, vector<int> (m)), horDown(n, vector<int> (m));
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int cnt = 0;
            for (int dir = 0; dir < 8; dir++) {
                int ni = i + dx[dir];
                int nj = j + dy[dir];
                if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                    if (dir == 0 || dir == 1 || dir == 7) {
                        cnt += a[ni][nj] == dir;
                    } else {
                        cnt += a[ni][nj] == inv(dir);
                    }
                }
            }
            horUp[i][j] = (cnt == cntN[i][j]);
            if (j > 0) {
                horUp[i][j] += horUp[i][j - 1];
            }
        }
    }

    for (int i = 0; i + 1 < n; i++) {
        for (int j = 0; j < m; j++) {
            int cnt = 0;
            for (int dir = 0; dir < 8; dir++) {
                int ni = i + dx[dir];
                int nj = j + dy[dir];
                if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                    if (dir == 3 || dir == 4 || dir == 5) {
                        cnt += a[ni][nj] == dir;
                    } else {
                        cnt += a[ni][nj] == inv(dir);
                    }
                }
            }
            horDown[i][j] = (cnt == cntN[i][j]);
            if (j > 0) {
                horDown[i][j] += horDown[i][j - 1];
            }
        }
    }

    vector<vector<int>> verLeft(n, vector<int> (m)), verRight(n, vector<int> (m));
    for (int j = 1; j < m; j++) {
        for (int i = 0; i < n; i++) {
            int cnt = 0;
            for (int dir = 0; dir < 8; dir++) {
                int ni = i + dx[dir];
                int nj = j + dy[dir];
                if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                    if (dir == 5 || dir == 6 || dir == 7) {
                        cnt += a[ni][nj] == dir;
                    } else {
                        cnt += a[ni][nj] == inv(dir);
                    }
                }
            }
            verLeft[i][j] = (cnt == cntN[i][j]);
            if (i > 0) {
                verLeft[i][j] += verLeft[i - 1][j];
            }
        }
    }

    for (int j = 1; j < m; j++) {
        for (int i = 0; i < n; i++) {
            int cnt = 0;
            for (int dir = 0; dir < 8; dir++) {
                int ni = i + dx[dir];
                int nj = j + dy[dir];
                if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                    if (dir == 1 || dir == 2 || dir == 3) {
                        cnt += a[ni][nj] == dir;
                    } else {
                        cnt += a[ni][nj] == inv(dir);
                    }
                }
            }
            verRight[i][j] = (cnt == cntN[i][j]);
            if (i > 0) {
                verRight[i][j] += verRight[i - 1][j];
            }
        }
    }

    vector<vector<int>> horPref(n, vector<int> (m)), verPref(n, vector<int> (m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int cnt = 0;
            for (int dir = 0; dir < 8; dir++) {
                int ni = i + dx[dir];
                int nj = j + dy[dir];
                if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                    if (dir == 6 || dir == 2) {
                        cnt += a[ni][nj] == dir;
                    } else {
                        cnt += a[ni][nj] == inv(dir);
                    }
                }
            }
            horPref[i][j] = (cnt == cntN[i][j]);
            if (j > 0) {
                horPref[i][j] += horPref[i][j - 1];
            }
        }
    }

    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            int cnt = 0;
            for (int dir = 0; dir < 8; dir++) {
                int ni = i + dx[dir];
                int nj = j + dy[dir];
                if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                    if (dir == 0 || dir == 4) {
                        cnt += a[ni][nj] == dir;
                    } else {
                        cnt += a[ni][nj] == inv(dir);
                    }
                }
            }
            verPref[i][j] = (cnt == cntN[i][j]);
            if (i > 0) {
                verPref[i][j] += verPref[i - 1][j];
            }
        }
    }

    for (int hor = 0; hor < n; hor++) {
        for (int ver = 0; ver < m; ver++) {
            if (hor >= 2 && ver >= 2 && pref[hor - 1][ver - 1] > 0) {
                for (int w = 0; w < hor - 1; w++) {
                    for (int k = 0; k < ver - 1; k++) {
                        if (good[w][k]) {
                            cout << w + 1 << ' ' << k + 1 << '\n';
                            cout << hor + 1 << ' ' << ver + 1 << '\n';
                            return;
                        }
                    }
                }
            }
            if (hor >= 2 && ver + 2 < m && getPref(0, ver + 2, hor - 2, m - 1) > 0) {
                for (int w = 0; w < hor - 1; w++) {
                    for (int k = ver + 2; k < m; k++) {
                        if (good[w][k]) {
                            cout << w + 1 << ' ' << k + 1 << '\n';
                            cout << hor + 1 << ' ' << ver + 1 << '\n';
                            return;
                        }
                    }
                }
            }
            if (hor + 2 < n && ver + 2 < m && getPref(hor + 2, ver + 2, n - 1, m - 1) > 0) {
                for (int w = hor + 2; w < n; w++) {
                    for (int k = ver + 2; k < m; k++) {
                        if (good[w][k]) {
                            cout << w + 1 << ' ' << k + 1 << '\n';
                            cout << hor + 1 << ' ' << ver + 1 << '\n';
                            return;
                        }
                    }
                }
            }
            if (hor + 2 < n && ver >= 2 && getPref(hor + 2, 0, n - 1, ver - 2) > 0) {
                for (int w = hor + 2; w < n; w++) {
                    for (int k = 0; k < ver - 1; k++) {
                        if (good[w][k]) {
                            cout << w + 1 << ' ' << k + 1 << '\n';
                            cout << hor + 1 << ' ' << ver + 1 << '\n';
                            return;
                        }
                    }
                }
            }
            if (hor > 0 && ver >= 2 && horDown[hor - 1][ver - 2] > 0) {
                for (int j = 0; j <= ver - 2; j++) {
                    if (horDown[hor - 1][j] == 1) {
                        cout << hor << ' ' << j + 1 << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (hor > 0 && ver + 2 < m && horDown[hor - 1][m - 1] - horDown[hor - 1][ver + 1] > 0) {
                for (int j = ver + 2; j < m; j++) {
                    if (horDown[hor - 1][j] - horDown[hor - 1][j - 1] == 1) {
                        cout << hor << ' ' << j + 1 << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (hor + 1 < n && ver >= 2 && horUp[hor + 1][ver - 2] > 0) {
                for (int j = 0; j <= ver - 2; j++) {
                    if (horUp[hor + 1][j] == 1) {
                        cout << hor + 2 << ' ' << j + 1 << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (hor > 0 && ver + 2 < m && horUp[hor - 1][m - 1] - horUp[hor - 1][ver + 1] > 0) {
                for (int j = ver + 2; j < m; j++) {
                    if (horUp[hor + 1][j] - horUp[hor + 1][j - 1] == 1) {
                        cout << hor + 2 << ' ' << j + 1 << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (ver > 0 && hor >= 2 && verRight[hor - 2][ver - 1] > 0) {
                for (int i = 0; i < hor - 1; i++) {
                    if (verRight[i][ver - 1] == 1) {
                        cout << i + 1 << ' ' << ver << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (ver > 0 && hor + 2 < n && verRight[n - 1][ver - 1] - verRight[hor + 1][ver - 1] > 0) {
                for (int i = hor + 2; i < n; i++) {
                    if (verRight[i][ver - 1] - verRight[i - 1][ver - 1] == 1) {
                        cout << i + 1 << ' ' << ver << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (ver + 1 < m && hor >= 2 && verLeft[hor - 2][ver + 1] > 0) {
                for (int i = 0; i < hor - 1; i++) {
                    if (verLeft[i][ver + 1] == 1) {
                        cout << i + 1 << ' ' << ver + 2 << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (ver + 1 < m && hor + 2 < n && verLeft[n - 1][ver + 1] - verLeft[hor + 1][ver + 1] > 0) {
                for (int i = hor + 2; i < n; i++) {
                    if (verLeft[i][ver + 1] - verLeft[i - 1][ver + 1] == 1) {
                        cout << i + 1 << ' ' << ver + 2 << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (ver - 1 >= 0 && hor - 1 >= 0) {
                int cnt = 0;
                int i = hor - 1;
                int j = ver - 1;
                for (int dir = 0; dir < 8; dir++) {
                    int ni = i + dx[dir];
                    int nj = j + dy[dir];
                    if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                        if (dir == 7 || dir == 6 || dir == 0) {
                            cnt += a[ni][nj] == inv(dir);
                        } else {
                            cnt += a[ni][nj] == dir;
                        }
                    }
                }
                if (cnt == cntN[i][j]) {
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    cout << hor + 1 << ' ' << ver + 1 << '\n';
                    return;
                }
            }
            if (hor - 1 >= 0 && ver + 1 < m) {
                int cnt = 0;
                int i = hor - 1;
                int j = ver + 1;
                for (int dir = 0; dir < 8; dir++) {
                    int ni = i + dx[dir];
                    int nj = j + dy[dir];
                    if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                        if (dir == 0 || dir == 1 || dir == 2) {
                            cnt += a[ni][nj] == inv(dir);
                        } else {
                            cnt += a[ni][nj] == dir;
                        }
                    }
                }
                if (cnt == cntN[i][j]) {
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    cout << hor + 1 << ' ' << ver + 1 << '\n';
                    return;
                }
            }
            if (hor + 1 < n && ver + 1 < m) {
                int cnt = 0;
                int i = hor + 1;
                int j = ver + 1;
                for (int dir = 0; dir < 8; dir++) {
                    int ni = i + dx[dir];
                    int nj = j + dy[dir];
                    if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                        if (dir == 2 || dir == 3 || dir == 4) {
                            cnt += a[ni][nj] == inv(dir);
                        } else {
                            cnt += a[ni][nj] == dir;
                        }
                    }
                }
                if (cnt == cntN[i][j]) {
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    cout << hor + 1 << ' ' << ver + 1 << '\n';
                    return;
                }
            }
            if (hor + 1 < n && ver - 1 >= 0) {
                int cnt = 0;
                int i = hor + 1;
                int j = ver - 1;
                for (int dir = 0; dir < 8; dir++) {
                    int ni = i + dx[dir];
                    int nj = j + dy[dir];
                    if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                        if (dir == 6 || dir == 5 || dir == 4) {
                            cnt += a[ni][nj] == inv(dir);
                        } else {
                            cnt += a[ni][nj] == dir;
                        }
                    }
                }
                if (cnt == cntN[i][j]) {
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    cout << hor + 1 << ' ' << ver + 1 << '\n';
                    return;
                }
            }
            if (hor - 1 >= 0) {
                int cnt = 0;
                int i = hor - 1;
                int j = ver;
                for (int dir = 0; dir < 8; dir++) {
                    int ni = i + dx[dir];
                    int nj = j + dy[dir];
                    if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                        if (dir == 3 || dir == 2 || dir == 6 || dir == 7) {
                            cnt += a[ni][nj] == inv(dir);
                        } else {
                            cnt += a[ni][nj] == dir;
                        }
                    }
                }
                if (cnt == cntN[i][j]) {
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    cout << hor + 1 << ' ' << ver + 1 << '\n';
                    return;
                }
            }
            if (hor + 1 < n) {
                int cnt = 0;
                int i = hor + 1;
                int j = ver;
                for (int dir = 0; dir < 8; dir++) {
                    int ni = i + dx[dir];
                    int nj = j + dy[dir];
                    if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                        if (dir == 2 || dir == 3 || dir == 5 || dir == 6) {
                            cnt += a[ni][nj] == inv(dir);
                        } else {
                            cnt += a[ni][nj] == dir;
                        }
                    }
                }
                if (cnt == cntN[i][j]) {
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    cout << hor + 1 << ' ' << ver + 1 << '\n';
                    return;
                }
            }
            if (ver - 1 >= 0) {
                int cnt = 0;
                int i = hor;
                int j = ver - 1;
                for (int dir = 0; dir < 8; dir++) {
                    int ni = i + dx[dir];
                    int nj = j + dy[dir];
                    if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                        if (dir == 0 || dir == 7 || dir == 5 || dir == 4) {
                            cnt += a[ni][nj] == inv(dir);
                        } else {
                            cnt += a[ni][nj] == dir;
                        }
                    }
                }
                if (cnt == cntN[i][j]) {
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    cout << hor + 1 << ' ' << ver + 1 << '\n';
                    return;
                }
            }
            if (ver + 1 < m) {
                int cnt = 0;
                int i = hor;
                int j = ver + 1;
                for (int dir = 0; dir < 8; dir++) {
                    int ni = i + dx[dir];
                    int nj = j + dy[dir];
                    if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                        if (dir == 0 || dir == 1 || dir == 3 || dir == 4) {
                            cnt += a[ni][nj] == inv(dir);
                        } else {
                            cnt += a[ni][nj] == dir;
                        }
                    }
                }
                if (cnt == cntN[i][j]) {
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    cout << hor + 1 << ' ' << ver + 1 << '\n';
                    return;
                }
            }
            if (1) {
                int cnt = 0;
                int i = hor;
                int j = ver;
                for (int dir = 0; dir < 8; dir++) {
                    int ni = i + dx[dir];
                    int nj = j + dy[dir];
                    if (ni >= 0 && nj >= 0 && ni < n && nj < m) {
                        if (dir == 1 || dir == 3 || dir == 5 || dir == 7) {
                            cnt += a[ni][nj] == inv(dir);
                        } else {
                            cnt += a[ni][nj] == dir;
                        }
                    }
                }
                if (cnt == cntN[i][j]) {
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    cout << hor + 1 << ' ' << ver + 1 << '\n';
                    return;
                }
            }
            if (ver >= 2 && horPref[hor][ver - 2] > 0) {
                for (int j = 0; j <= ver - 2; j++) {
                    if (horPref[hor][j] == 1) {
                        cout << hor + 1 << ' ' << j + 1 << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (ver + 2 < m && horPref[hor][m - 1] - horPref[hor][ver + 1] > 0) {
                for (int j = ver + 2; j < m; j++) {
                    if (horPref[hor][j] - horPref[hor][j - 1] == 1) {
                        cout << hor + 1 << ' ' << j + 1 << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (hor >= 2 && verPref[hor - 2][ver] > 0) {
                for (int i = 0; i < hor - 1; i++) {
                    if (verPref[i][ver] == 1) {
                        cout << i + 1 << ' ' << ver + 1 << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
            if (hor + 2 < n && verPref[n - 1][ver] - verPref[hor + 1][ver] > 0) {
                for (int i = hor + 2; i < n; i++) {
                    if (verPref[i][ver] - verPref[i - 1][ver] == 1) {
                        cout << i + 1 << ' ' << ver + 1 << '\n';
                        cout << hor + 1 << ' ' << ver + 1 << '\n';
                        return;
                    }
                }
            }
        }
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
