#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

#ifdef LOCAL

#include "debug.h"

#else
#define debug(...) 42
#endif

struct Node {
    Node *l = nullptr, *r = nullptr;
    int push = -1;
    int c = -1;

    Node() = default;
};

int c;

void push(Node *v) {
    if (v->push == -1) {
        return;
    }
    if (v->l == nullptr) {
        v->l = new Node();
    }
    if (v->r == nullptr) {
        v->r = new Node();
    }
    v->l->push = (v->push + 1) % c;
    v->r->push = (v->push - 1 + c) % c;
    v->c = v->push;
    v->push = -1;
}

void creatend(Node *&v) {
    if (v == nullptr) {
        v = new Node();
    }
}

int get(Node *&v, int cur, const string &s) {
    creatend(v);
    push(v);
    if (cur == (int) s.size()) {
        return v->c;
    }
    if (s[cur] == 'L') {
        return get(v->l, cur + 1, s);
    } else {
        return get(v->r, cur + 1, s);
    }
}

void update(Node *&v, int cur, const string &s, int x) {
    creatend(v);
    push(v);
    if (cur == (int) s.size()) {
        v->push = x;
        push(v);
        return;
    }
    if (s[cur] == 'L') {
        update(v->l, cur + 1, s, x);
    } else {
        update(v->r, cur + 1, s, x);
    }
}

void solve() {
    int q;
    cin >> q >> c;
    Node *root = nullptr;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            string s;
            cin >> s;
            update(root, 0, s, x);
        } else {
            string s;
            cin >> s;
            cout << get(root, 0, s) << "\n";
        }
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
