#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

const ld EPS = 1e-7;

struct Point {
    ll x = 0, y = 0;

    Point() : x(0), y(0) {}
    Point(ll _x, ll _y) : x(_x), y(_y) {}

};

istream &operator>>(istream &is, Point &point) {
    is >> point.x >> point.y;
    return is;
}

ostream &operator<<(ostream &os, const Point &point) {
    os << point.x << ' ' << point.y;
    return os;
}

struct Vec {
    ll x, y;

    Vec() : x(0), y(0) {}
    Vec(ll _x, ll _y) : x(_x), y(_y) {}
    Vec(Point a) : x(a.x), y(a.y) {}
    Vec(Point a, Point b) : x(b.x - a.x), y(b.y - a.y) {}

    ld len() const {
        return sqrtl(x * x + y * y);
    }

    ll operator*(const Vec other) const {
        return x * other.x + y * other.y;
    }

    ll operator%(const Vec other) const {
        return x * other.y - y * other.x;
    }
};

ld from_point_to_segment(const Point &p, const Point &a, const Point &b) {
    Vec ab(a, b), ap(a, p), bp(b, p), ba(b, a);
    if ((ab * ap) < 0) {
        return fabsl(ap.len());
    } else if ((ab * bp) > 0) {
        return fabsl(bp.len());
    } else {
        return fabsl((ba % ap) / ba.len());
    }
}

int get_sign(ld x) {
    if (x > 0) return 1;
    if (x < 0) return -1;
    return 0;
}

bool segment_intersection(const Point &a, const Point &b, const Point &c, const Point &d) {
    Vec ab(a, b), cd(c, d), ac(a, c), ad(a, d), cb(c, b), ca(c, a);
    if (get_sign((ab % ac)) * get_sign((ab % ad)) <= 0 && get_sign((cd % ca)) * get_sign((cd % cb)) <= 0) {
        ll x1 = max(min(a.x, b.x), min(c.x, d.x)), x2 = min(max(a.x, b.x), max(c.x, d.x));
        ll y1 = max(min(a.y, b.y), min(c.y, d.y)), y2 = min(max(a.y, b.y), max(c.y, d.y));
        return (x1 <= x2 && y1 <= y2);
    }
    return false;
}

bool check(pair<Point, Point> a, pair<Point, Point> b, pair<Point, Point> c) {
    if (segment_intersection(a.first, a.second, b.first, b.second)) {
        return true;
    }

    ld dist = min({from_point_to_segment(a.first, b.first, b.second),
                   from_point_to_segment(a.second, b.first, b.second),
                   from_point_to_segment(b.first, a.first, a.second),
                   from_point_to_segment(b.second, a.first, a.second)
                   });
    Vec cc(c.first, c.second);
    if (dist - EPS < cc.len()) {
        return true;
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<Point, Point>> a(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                if (check(a[i], a[j], a[k]) ||
                    check(a[i], a[k], a[j]) ||
                    check(a[j], a[k], a[i])) {
                    ++ans;
                }
            }
        }
    }
    cout << ans << en;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
