#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;

int n;
vector<ll>arr, tree;

void build(int l = 0, int r = n, int v = 0) {
	if (l + 1 == r) {
		tree[v] = arr[l];
		return;
	}
	int  m = (l + r) / 2;
	build(l, m, 2 * v + 1);
	build(m, r, 2 * v + 2);
	tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}
ll get(int ql, int qr, int l = 0, int r = n, int v = 0) {
	if (ql <= l && r <= qr) {
		return tree[v];
	}
	if (r <= ql || qr <= l)
		return 1e9 + 10;
	int m = (l + r) / 2;
	return min(get(ql, qr, l, m, 2 * v + 1), get(ql, qr, m, r, 2 * v + 2));
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cin >> n;
	arr.resize(n);
	tree.resize(4 * n);
	ll sum = 0;
	vector<ll>pref(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		sum += arr[i];
		pref[i] = arr[i] + (i != 0 ? pref[i - 1] : 0);
	}
	build();
	int ans = n;
	for (int i = 0; i < n; i++) {
		int l = -1, r = i + 1;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (2 * (pref[i] - (m == 0 ? 0 : pref[m - 1])) >= sum)
				l = m;
			else
				r = m;
		}
		if (l == -1)
			continue;
		ans = min(ans, i - l + 1);
		ll score = (pref[i] - (l == 0 ? 0 : pref[l - 1])) - get(l, i + 1);
		if (score * 2 >= sum)
			ans = min(ans, i - l);
	}
	cout << ans;
	return 0;
}