#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <array>

using namespace std;

typedef long long ll;

constexpr int SIZE = 1e6;

array<int, 26>go[SIZE];
int sz[SIZE];
int T = 0;

int create() {
	for (int i = 0; i < 26; i++)
		go[T][i] = -1;
	sz[T] = 0;
	return T++;
}

string s;
void add(int v, int i = 0) {
	sz[v]++;
	if (i == s.size())
		return;
	if (go[v][s[i] - 'a'] == -1)
		go[v][s[i] - 'a'] = create();
	add(go[v][s[i] - 'a'], i + 1);
}

int dfs(int v, int deep = 0) {
	for (int i = 0; i < 26; i++) {
		if (go[v][i] != -1 && sz[go[v][i]] % 2 != 0)
			return deep;
	}
	int ans = 1e9;
	for (int i = 0; i < 26; i++) {
		if (go[v][i] != -1)
			ans = min(ans, dfs(go[v][i], deep + 1));
	}
	return ans;
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int root = create();
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> s;
		add(root);
	}
	cout << dfs(root);
	return 0;
}