#include <bits/stdc++.h>

using namespace std;

struct vec {
    int x{}, y{};
};

istream &operator>>(istream &in, vec &v) {
    in >> v.x >> v.y;
    return in;
}

vec operator+(const vec &lhs, const vec &rhs) {
    return {lhs.x + rhs.x, lhs.y + rhs.y};
}

vec operator-(const vec &lhs, const vec &rhs) {
    return {lhs.x - rhs.x, lhs.y - rhs.y};
}

int64_t operator*(const vec &lhs, const vec &rhs) {
    return (int64_t) lhs.x * rhs.y - (int64_t) lhs.y * rhs.x;
}

int64_t operator%(const vec &lhs, const vec &rhs) {
    return (int64_t) lhs.x * rhs.x + (int64_t) lhs.y * rhs.y;
}

vec V(vec a, vec b) {
    return b - a;
}

long double dist(vec a, vec b) {
    vec v = V(a, b);
    return sqrtl((long double) v.x * v.x + (long double) v.y * v.y);
}

long double dist(vec a, vec b, vec c) {
    if (V(a, b) % V(a, c) >= 0 && V(b, a) % V(b, c) >= 0) {
        return (long double) abs(V(a, c) * V(a, b)) / dist(a, b);
    }
    return min(dist(c, a), dist(c, b));
}

int sgn(int64_t x) {
    if (x > 0) {
        return 1;
    }
    if (x < 0) {
        return -1;
    }
    return 0;
}

long double dist(vec a, vec b, vec c, vec d) {
    int x1 = a.x, x2 = b.x, x3 = c.x, x4 = d.x;
    int y1 = a.y, y2 = b.y, y3 = c.y, y4 = d.y;
//    cout << (max({x1, x2, x3, x4}) - min({x1, x2, x3, x4}) > abs(x2 - x1) + abs(x3 - x4)) << "\n";
//    cout << (max({y1, y2, y3, y4}) - min({y1, y2, y3, y4}) > abs(y2 - y1) + abs(y3 - y4)) << "\n";
//    cout << (sgn(V(a, b) * V(a, d)) * sgn(V(a, b) * V(a, c)) <= 0) << "\n";
//    cout << (sgn(V(c, d) * V(c, a)) * sgn(V(c, d) * V(c, b)) <= 0) << "\n";
    if (max({x1, x2, x3, x4}) - min({x1, x2, x3, x4}) <= abs(x2 - x1) + abs(x3 - x4) &&
        max({y1, y2, y3, y4}) - min({y1, y2, y3, y4}) <= abs(y2 - y1) + abs(y3 - y4) &&
            sgn(V(a, b) * V(a, d)) * sgn(V(a, b) * V(a, c)) <= 0 &&
            sgn(V(c, d) * V(c, a)) * sgn(V(c, d) * V(c, b)) <= 0) {
        return 0;
    }
    return min({dist(a, b, c), dist(a, b, d), dist(c, d, a), dist(c, d, b)});
}

int main() {
    int n;
    cin >> n;

    vector<vec> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }

    int ans = 0;

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int k = j + 1; k < n; k++) {
                if (dist(a[i], b[i], a[j], b[j]) <= dist(a[k], b[k]) || dist(a[i], b[i], a[k], b[k]) <= dist(a[j], b[j]) ||
                        dist(a[j], b[j], a[k], b[k]) <= dist(a[i], b[i])) {
                    ans++;
                }
            }
        }
    }
    cout << ans << "\n";
}