#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

int root = 0, next_node = 0;
struct Node {
    int left, right, t, x;
    Node() : left(-1), right(-1), t(-1), x(-1) {}
};

vector<Node> nodes;
int new_node() {
    nodes.emplace_back();
    return next_node++;
}

void add(string& s, int t, int x) {
    int node_id = root;

    for (int i = 0; i < (int)s.size(); i++) {
        if (s[i] == 'R') {
            if (nodes[node_id].right == -1) {
                nodes[node_id].right = new_node();
            }

            node_id = nodes[node_id].right;
        } else if (s[i] == 'L') {
            if (nodes[node_id].left == -1) {
                nodes[node_id].left = new_node();
            }

            node_id = nodes[node_id].left;
        }
    }

    nodes[node_id].t = t;
    nodes[node_id].x = x;
}

pair<int, int> get(string& s) {
    int node_id = root;
    int ansi = -1, anst = -1, ansx = -1;

    for (int i = 0; i < (int)s.size(); i++) {
        if (s[i] == 'R') {
            if (nodes[node_id].right == -1)
                break;
            node_id = nodes[node_id].right;
        } else if (s[i] == 'L') {
            if (nodes[node_id].left == -1)
                break;
            node_id = nodes[node_id].left;
        }

        if (nodes[node_id].t > anst) {
            anst = nodes[node_id].t;
            ansx = nodes[node_id].x;
            ansi = i + 1;
        }
    }

    return {ansi, ansx};
}

void solve() {
    int q, c;
    cin >> q >> c;

    new_node();

    int type;
    for (int i = 0; i < q; i++) {
        cin >> type;

        if (type == 1) {
            int x;
            cin >> x;

            string s;
            cin >> s;

            add(s, i, x);
        } else if (type == 2) {
            string s;
            cin >> s;

            auto [start, x] = get(s);
            if (start == -1) {
                cout << "-1\n";
                continue;
            }

            for (int j = start; j < (int)s.size(); j++) {
                if (s[j] == 'R') {
                    x = (x - 1 + c) % c;
                } else if (s[j] == 'L') {
                    x = (x + 1) % c;
                }
            }

            cout << x << '\n';
        }
    }
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}