#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

struct Vector {
    ll x, y;
    Vector(ll x, ll y) : x(x), y(y) {}
    Vector() : x(0), y(0) {}
    Vector operator+(Vector other) {
        return {x + other.x, y + other.y};
    }
    Vector operator-(Vector other) {
        return {x - other.x, y - other.y};
    }
    ll operator*(Vector other) {
        return x * other.x + y * other.y;
    }
    ll operator%(Vector other) {
        return x * other.y - y * other.x;
    }
};

bool between(ll a1, ll a2, ll b1, ll b2) {
    if (a1 > a2)
        swap(a1, a2);
    if (b1 > b2)
        swap(b1, b2);
    return max(a1, b1) <= min(a2, b2);
}

bool are_crossing(Vector a1, Vector a2, Vector b1, Vector b2) {
    Vector v1 = b1 - a1, v2 = b2 - a1, v3 = a2 - a1;
    ll cross1 = v3 % v1, cross2 = v3 % v2;
    if (cross1 > 0 && cross2 > 0 || cross1 < 0 && cross2 < 0)
        return false;
    v1 = a1 - b1, v2 = a2 - b1, v3 = b2 - b1;
    cross1 = v3 % v1, cross2 = v3 % v2;
    if (cross1 > 0 && cross2 > 0 || cross1 < 0 && cross2 < 0)
        return false;
    if (!between(a1.x, a2.x, b1.x, b2.x))
        return false;
    if (!between(a1.y, a2.y, b1.y, b2.y))
        return false;
    return true;
}

struct road {
    Vector a, b;
};

bool are_crossing(road first, road second) {
    return are_crossing(first.a, first.b, second.a, second.b);
}

bool check(road a, road b, road c) {
    if (are_crossing(a, b))
        return true;
    Vector l1 = a.a - b.b, l2 = a.a - b.a, l3 = a.b - b.a, l4 = a.b - b.b;
    ll l = min(l1 * l1, l2 * l2);
    l = min(l, l3 * l3);
    l = min(l, l4 * l4);
    if (l <= (c.a - c.b) * (c.a - c.b))
        return true;
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector<road> roads(n);
    for (int i = 0; i < n; i++) {
        cin >> roads[i].a.x >> roads[i].a.y >> roads[i].b.x >> roads[i].b.y;
    }
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int k = j + 1; k < n; k++) {
                if (check(roads[i], roads[j], roads[k]) || check(roads[i], roads[k], roads[j]) || check(roads[j], roads[k], roads[i])) {
                    ans += 1;
                }
            }
        }
    }
    cout << ans;
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}