#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <fstream>

using namespace std;

#define int unsigned long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

const int inf = 1e18;
const int mod = 1e9 + 7;

int fastPow(int a, int b)
{
    if (b == 0)
        return 1;
    int x = fastPow(a, b / 2);
    if (b % 2 == 0)
        return x * x;
    return x * x * a;
}

int myMinus(int a, int b)
{
    if (a > b)
        return a - b;
    return 0;
}

int check(int l, int r)
{
    int ans = 0;
    for(int len = 1; len <= 18; len ++)
    {
        int left = fastPow(10, len - 1);
        int right = fastPow(10, len) - 1;
        if (len == 1)
            left = 0;
        int here = myMinus(min(right, r) + 1, max(left, l));
        ans += here * len;
    }
    return ans;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int N;
    cin >> N;
    int n = N;
    if (n <= 10)
        return cout << n << '\n' << 0 << ' ' << n - 1, 0;

    n -= 10;
    int len = 2;
    int now = 90;
    while(n > now * len)
    {
        n -= now * len;
        now *= 10;
        len ++;
    }

    int k = n / len;
    int rest = (n % len);
    int l = 0, r = fastPow(10, len - 1) + k - 1;

    if(rest > 0)
    {
        r++;
        l += (len - rest);
    }

    l = myMinus(l, 1000);
    r = myMinus(r, 1000);
    for(;l < inf; l++)
        for(; r < inf; r++)
        {
            int ans = check(l, r);
            if(ans == N)
                return cout << r - l + 1 << '\n' << l << " " << r << '\n', 0;
            if(ans > N)
                break;
        }
    return 42;
}

