#pragma GCC optimize("Ofast,O2,O3")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

#define MP make_pair
#define x first
#define y second
#define point pair<ll,ll>
#define line pair<point,point>

ll dist2(point a, point b){
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

ll dist2(line a){
    return dist2(a.first, a.second);
}

ll dist2_between_lines(line a, line b){
    ll res = 1e18;
    res = min(res, dist2(a.first, b.first));
    res = min(res, dist2(a.first, b.second));
    res = min(res, dist2(a.second, b.first));
    res = min(res, dist2(a.second, b.second));
    return res;
}

int magic(point p, point a, point b){
    if (a.x == b.x){
        if (p.x < a.x) return -1;
        if (p.x == a.x) return 0;
        if (p.x > a.x) return 1;
    } else {
        long double _k = (long double) (b.y - a.y) / (b.x - a.x);
        long double _b = a.y - _k * a.x;

        long double f = _k * p.x + _b;

        if (abs(f - p.y) <= 1e-8) return 0;
        if (f < p.y) return -1;
        return 1;
    }
}

bool intersect(line a, line b){
    if (magic(a.first, b.first, b.second) * magic(a.second, b.first, b.second) == 1) return false;
    if (magic(b.first, a.first, a.second) * magic(b.second, a.first, a.second) == 1) return false;
    return true;
}

void solve(){
    int n;
    cin >> n;

    vector<line> v;
    for (int i = 0; i < n; i++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        v.emplace_back(MP(a, b), MP(c, d));
    }

    int ans = 0;
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++){
            for (int k = j + 1; k < n; k++){
                bool ok = false;

                if (dist2(v[i]) >= dist2_between_lines(v[j], v[k])) ok = true;
                if (dist2(v[j]) >= dist2_between_lines(v[i], v[k])) ok = true;
                if (dist2(v[k]) >= dist2_between_lines(v[i], v[j])) ok = true;

                if (intersect(v[i], v[j]) && intersect(v[i], v[k])) ok = true;
                if (intersect(v[j], v[i]) && intersect(v[j], v[k])) ok = true;
                if (intersect(v[k], v[i]) && intersect(v[k], v[j])) ok = true;

                if (ok) ans++;
            }
        }
    }

    cout << ans << endl;

}

int main(){
    ios_base::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    int tc = 1;
    //cin >> tc;

    while (tc--) solve();

    return 0;
}
