﻿#include<iostream>
#include<string>
#include<vector>
#include<map>
#include<set>
#include<cmath>

using namespace std;

typedef long long ll;

ll q, MOD;

struct Node
{
	ll color = -1;
	ll l = -1, r = -1;
};

vector<Node> tree;
vector<ll> p;

void build() {
	tree.emplace_back();
	p.emplace_back(-1);
}

void push(ll idx) {
	if (p[idx] != -1) {
		ll c = tree[idx].color;
		ll l = tree[idx].l;
		ll r = tree[idx].r;
		if (l == -1) {
			tree.emplace_back();
			p.emplace_back(-1);
			ll n = tree.size() - 1;
			tree[idx].l = n;
			l = n;
		}
		if (r == -1) {
			tree.emplace_back();
			p.emplace_back(-1);
			ll n = tree.size() - 1;
			tree[idx].r = n;
			r = n;
		}
		tree[l].color = (c + 1) % MOD;
		p[l] = (c + 1) % MOD;
		tree[r].color = (c - 1 + MOD) % MOD;
		p[r] = (c - 1 + MOD) % MOD;
		p[idx] = -1;
	}
}

void update(string s, ll x) {
	ll idx = 0;
	for (auto elem : s) {
		ll c = tree[idx].color;
		ll l = tree[idx].l;
		ll r = tree[idx].r;
		if (elem == 'L') {
			if (l == -1) {
				tree.emplace_back();
				p.emplace_back(-1);
				ll n = tree.size() - 1;
				tree[idx].l = n;
				l = n;
			}
			push(idx);
			idx = l;
		} else {
			if (r == -1) {
				tree.emplace_back();
				p.emplace_back(-1);
				ll n = tree.size() - 1;
				tree[idx].r = n;
				r = n;
			}
			push(idx);
			idx = r;
		}
	}
	tree[idx].color = x;
	p[idx] = x;
}

ll get(string s) {
	ll idx = 0;
	for (auto elem : s) {
		ll c = tree[idx].color;
		ll l = tree[idx].l;
		ll r = tree[idx].r;
		if (elem == 'L') {
			if (l == -1) {
				tree.emplace_back();
				p.emplace_back(-1);
				ll n = tree.size() - 1;
				tree[idx].l = n;
				l = n;
			}
			push(idx);
			idx = l;
		} else {
			if (r == -1) {
				tree.emplace_back();
				p.emplace_back(-1);
				ll n = tree.size() - 1;
				tree[idx].r = n;
				r = n;
			}
			push(idx);
			idx = r;
		}
	}
	return tree[idx].color;
}

int main() {
	build();
	cin >> q >> MOD;
	while (q--) {
		ll t;
		cin >> t;
		if (t == 1) {
			ll x;
			string s;
			cin >> x >> s;
			update(s, x);
		} else {
			string s;
			cin >> s;
			cout << get(s) << "\n";
		}
	}
	return 0;
}