//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
#include "bits/stdc++.h"
#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()
using namespace std;

const ld EPS = 1e-10;

int sign(int x) {
    if (x > 0) return 1;
    if (x < 0) return -1;
    return 0;
}

int sign(ld x) {
    if (x > EPS) return 1;
    if (x < -EPS) return -1;
    return 0;
}

int sq(int x) {
    return x * x;
}

ld sq(ld x) {
    return x * x;
}

#define Vec Point

struct Point {
    ld x, y;
    Point() {
        x = 0, y = 0;
    }
    Point(ld _x, ld _y) {
        x = _x, y = _y;
    }
    Point operator-(const Point& other) const {
        return {x - other.x, y - other.y};
    }
    Point operator+(const Point& other) const {
        return {x + other.x, y + other.y};
    }
    Point operator*(const ld& other) const {
        return {x * other, y * other};
    }
    ld operator^(const Point& other) const {
        return x * other.y - y * other.x;
    }
    ld operator*(const Point& other) const {
        return x * other.x + y * other.y;
    }
    ld len2() const {
        return sq(x) + sq(y);
    }
    ld len() const {
        return sqrtl(len2());
    }
    bool operator<(const Point& other) const {
        if (sign(x - other.x) != 0) {
            return x < other.x;
        }
        if (sign(y - other.y) != 0) {
            return y < other.y;
        }
        return false;
    }
    bool operator==(const Point& other) const {
        return sign(x - other.x) == 0 && sign(y - other.y) == 0;
    }
    bool operator<=(const Point& other) const {
        return Point(x, y) < other || Point(x, y) == other;
    }
    friend istream& operator>>(istream& is, Point& other) {
        is >> other.x >> other.y;
        return is;
    }
};

bool check(ld la, ld ra, ld lb, ld rb) {
    return sign(min(ra, rb) - max(la, lb)) >= 0;
}

bool isCrossed(const Point& a, const Point& b, const Point& c, const Point& d) {
    if (!check(min(a.x, b.x), max(a.x, b.x), min(c.x, d.x), max(c.x, d.x))) return false;
    if (!check(min(a.y, b.y), max(a.y, b.y), min(c.y, d.y), max(c.y, d.y))) return false;
    Vec v1, v2, v3;
    v1 = b - a;
    v2 = c - a;
    v3 = d - a;
    if (sign(v1 ^ v2) * sign(v1 ^ v3) == 1) return false;
    v1 = d - c;
    v2 = a - c;
    v3 = b - c;
    if (sign(v1 ^ v2) * sign(v1 ^ v3) == 1) return false;
    return true;
}

struct Line {
    int a, b, c;
    Line() {
        a = 0, b = 0, c = 0;
    }
    Line(const Point& A, const Point& B) {
        a = B.y - A.y;
        b = A.x - B.x;
        c = A.y * B.x - A.x * B.y;
        if (sign(a) == -1) {
            a = -a;
            b = -b;
            c = -c;
        }
        else if (sign(a) == 0 && sign(b) == -1) {
            a = 0;
            b = -b;
            c = -c;
        }
    }
};

ld dist(const Point& a, const Line& l) {
    return fabsl(l.a * a.x + l.b * a.y + l.c) / sqrtl(sq(l.a) + sq(l.b));
}

ld fromPointToPoint(const Point& a, const Point& c) {
    return Point(c - a).len();
}

ld fromPointToSegment(const Point& a, const Point& c, const Point& d) {
    Line temp(c, d);
    ld ans = min(fromPointToPoint(a, c), fromPointToPoint(a, d)), l = dist(a, temp);
    if (sign(Point(d - c) * Point(a - c)) == 1 && sign(Point(c - d) * Point(a - d)) == 1) {
        ans = l;
    }
    return ans;
}

ld fromSegmentToSegment(const Point& a, const Point& b, const Point& c, const Point& d) {
    ld ans = min({fromPointToSegment(a, c, d), fromPointToSegment(b, c, d), fromPointToSegment(c, a, b), fromPointToSegment(d, a, b)});
    if (isCrossed(a, b, c, d)) {
        ans = 0;
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int m;
    cin >> m;
    vector <pair <Point, Point>> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            for (int k = j + 1; k < m; ++k) {
                if (isCrossed(a[i].first, a[i].second, a[j].first, a[j].second) ||
                    isCrossed(a[i].first, a[i].second, a[k].first, a[k].second) ||
                    isCrossed(a[j].first, a[j].second, a[k].first, a[k].second) ||
                    sign(Point(a[k].first - a[k].second).len() - fromSegmentToSegment(a[i].first, a[i].second, a[j].first, a[j].second)) >= 0 ||
                    sign(Point(a[j].first - a[j].second).len() - fromSegmentToSegment(a[i].first, a[i].second, a[k].first, a[k].second)) >= 0 ||
                    sign(Point(a[i].first - a[i].second).len() - fromSegmentToSegment(a[j].first, a[j].second, a[k].first, a[k].second)) >= 0) {
                    ++ans;
                }
            }
        }
    }
    cout << ans;
    return 0;
}