#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
using namespace std;
const long long N = 2e5 + 10, INF = 1e9 + 10;
long long a[N], pref[N], tree[N];
void build_tree(int v, int tl, int tr) {
	if (tl == tr)
		tree[v] = a[tl];
	else {
		int tm = (tl + tr) / 2;
		build_tree(2 * v, tl, tm);
		build_tree(2 * v + 1, tm + 1, tr);
		tree[v] = min(tree[2 * v], tree[2 * v + 1]);
	}
}
long long Min(int v, int tl, int tr, int l, int r) {
	if (tl > r || tr < l) return INF;
	else if (tl >= l && tr <= r) return tree[v];
	else {
		int tm = (tl + tr) / 2;
		return min(Min(2 * v, tl, tm, l, r), Min(2 * v + 1, tm + 1, tr, l, r));
	}
}
void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	build_tree(1, 0, n - 1);
	pref[0] = a[0];
	for (int i = 1; i < n; i++) {
		pref[i] = pref[i - 1] + a[i];
	}
	int Ans = n;
	for (int i = 0; i < n; i++) {
		int l = i, r = n - 1, ans = -1;
		long long k = 0;
		if (i) k = pref[i - 1];
		while (l <= r) {
			int mid = (l + r) / 2;
			if (2 * (pref[mid] - pref[i - 1]) >= pref[n - 1]) {
				r = mid - 1;
				ans = mid;
			}
			else l = mid + 1;
		}
		if (ans != -1) Ans = min(Ans, ans - i + 1);
	}
	for (int i = 0; i < n; i++) {
		int l = i, r = n - 1, ans = -1;
		long long k = 0;
		if (i) k = pref[i - 1];
		while (l <= r) {
			int mid = (l + r) / 2;
			if (2 * (pref[mid] - pref[i - 1] - Min(1, 0, n - 1, i, mid)) >= pref[n - 1]) {
				r = mid - 1;
				ans = mid;
			}
			else l = mid + 1;
		}
		if (ans != -1) Ans = min(Ans, ans - i);
	}
	cout << Ans << "\n";
}
int main()
{
	int t = 1;
	while (t--) {
		solve();
	}
}