#include <iostream>


using namespace std;
using ll = long long;

const int N = 1e5 + 3;

int Q, C, t = 1;

struct segtree {

    int col, tim;
    segtree* left = 0, * right = 0;

    segtree(int a) {
        col = -1;
        tim = 0;
    }

    void update(string& s, int i, int c) {
        if (left == nullptr) {
            left = new segtree(0);
        }
        if (right == nullptr) {
            right = new segtree(0);
        }
        if (i == s.size()) {
            col = c;
            tim = t;
            left->tim = t;
            right->tim = t;
            ++t;
            left->col = (c + 1) % C;
            right->col = (c - 1 + C) % C;
            return;
        }
        if (s[i] == 'L') {
            if (left->tim < tim) {
                left->col = (c + 1) % C;
                left->tim = tim;
            }
            left->update(s, i + 1, c);
        }
        else {
            if (right->tim < tim) {
                right->col = (c - 1 + C) % C;
                right->tim = tim;
            }
            right->update(s, i + 1, c);
        }
    }

    int get_sum(string& s, int i) {
        if (left == nullptr) {
            left = new segtree(0);
        }
        if (right == nullptr) {
            right = new segtree(0);
        }
        if (i == s.size()) {
            return col;
        }
        if (s[i] == 'L') {
            return left->get_sum(s, i + 1);
        }
        else {
            return right->get_sum(s, i + 1);
        }
    }
};


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> Q >> C;

    segtree sg(0);

    while (Q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            string s;
            cin >> s;
            sg.update(s, 0, x);
        }
        else {
            string s;
            cin >> s;
            cout << sg.get_sum(s, 0) << "\n";
        }
    }
}