#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int INF = 2e9 + 3, N = 1e5 + 3, S = 20;

int a[N];

struct mystack
{
    stack<pair<int, int>> s;
    ll sum = 0;
    void push(int x){
        sum += (ll)x;
        if(s.empty()) s.push({x, x});
        else s.push({x, min(x, s.top().second  )});
    }
    int top(){
        int x = s.top().first;
        return x;
    }
    int get_min(){
        if(s.empty()) return INF;
        return s.top().second;
    }
    bool empty(){
        return s.empty();
    }

    void pop(){
        sum -= s.top().first;
        s.pop();
    }
    int size(){
        return s.size();
    }

};

struct myqueue
{
    mystack in, out;
    void push(int x){
        in.push(x);
    }

    void move(){
        if(out.empty()){
            out.push(in.top());
            in.pop();
        }
    }

    void pop(){
        move();
        out.pop();
    }

    int front(){
        move();
        return out.top();
    }

    int get_min(){
        return min(in.get_min(), out.get_min());
    }
    ll get_sum(){
        return in.sum + out.sum;
    }
    int size(){
        return in.size() + out.size();
    }
};



int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    ll s = 0;

    for(int i = 0; i < n; ++i){
        int x;
        cin >> x;
        s += x;
        a[i] = x;
    }
    int ans = INF;
    myqueue q;
    for(int i = 0; i < n; ++i){
        q.push(a[i]);
        while(2 * (q.get_sum() - q.front()) >= s){
            q.pop();
        }
        if( 2 * q.get_sum() >= s){
            ans = min(ans, q.size());
            if(2 * (q.get_sum() - q.get_min()) >= s){
                ans = min(ans, q.size() - 1);
            }
        }

    }
    cout << ans;
    return 0;
}