#include <bits/stdc++.h>

#define ll long long

using namespace std;

struct seg_tree{
    int size;
    vector<ll> tree;

    seg_tree(int n) {
        size = 1;
        while(size < n) size *= 2;
        tree.resize(2 * size - 1, 0);
    }

    void set(int i, ll v, int x, int lx, int rx) {
        int m = (lx + rx) / 2;
        if(rx - lx == 1) {
            tree[x] = v;
            return;
        }
        else if(i < m) {
            set(i, v, 2 * x + 1, lx, m);
        }
        else{
            set(i, v, 2 * x + 2, m, rx);
        }
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }

    void set(int i, ll v) {
        set(i, v, 0, 0, size);
    }

    ll mn(int l, int r, int x, int lx, int rx) {
        if(rx <= l or r <= lx) {
            return LONG_LONG_MAX;
        }
        else if(l <= lx and rx <= r) {
            return tree[x];
        }
        else{
            int m = (lx + rx) / 2;
            return min(mn(l, r, 2 * x + 1, lx, m), mn(l, r, 2 * x + 2, m, rx));
        }
    }

    ll mn(int l, int r) {
        return mn(l, r, 0, 0, size);
    }
};

int main() {
    int n; cin >> n;
    vector<ll> a(n), pre(n + 1, 0);
    ll sum = 0;
    seg_tree st = seg_tree(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
        pre[i + 1] = pre[i] + a[i];
        sum += a[i];
        st.set(i, a[i]);
    }
    int l = 0, r = 0;
    int ans0 = INT_MAX;
    while(r < n or l < n) {
        if(2 * (pre[r] - pre[l]) >= sum) {
            ans0 = min(ans0, r - l);
        }
        if(2 * (pre[r] - pre[l]) < sum and r + 1 <= n) {
            r++;
        }
        else{
            l++;
        }
        if(2 * (pre[r] - pre[l]) >= sum) {
            ans0 = min(r - l, ans0);
        }
    }
    int ans1 = INT_MAX;
    l = 0;
    r = 0;
    while(r < n or l < n) {
        if(2 * (pre[r] - pre[l] - st.mn(l, r)) >= sum) {
            ans1 = min(ans1, r - l - 1);
        }
        if(2 * (pre[r] - pre[l] - st.mn(l, r)) < sum and r + 1 <= n) {
            r++;
        }
        else{
            l++;
        }
        if(2 * (pre[r] - pre[l] - st.mn(l, r)) >= sum) {
            ans1 = min(ans1, r - l - 1);
        }
    }
    cout << min(ans0, ans1);
}