﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct MinQue {
	vector<pair<int, int>> stack1;
	vector<pair<int, int>> stack2;
	void push(int el) {
		if (stack1.empty()) {
			stack1.push_back({ el, el });
		}
		else {
			stack1.push_back({ el, min(el, stack1.back().second) });
		}
	}

	void pop() {
		if (stack2.empty()) {
			while (!stack1.empty()) {
				if (stack2.empty()) {
					stack2.push_back(stack1.back());
				}
				else {
					stack2.push_back({ stack1.back().first, min(stack1.back().first, stack2.back().second) });
				}
				stack1.pop_back();
			}
		}
		stack2.pop_back();
	}

	int get_min() {
		if (stack1.empty()) {
			return stack2.back().second;
		}
		if (stack2.empty()) {
			return stack1.back().second;
		}
		return min(stack1.back().second, stack2.back().second);
	}
};


int main() {
	int n;
	cin >> n;
	vector<int> a(n);
	long long com_s = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		com_s += a[i];
	}
	vector<int> p(n + 1);
	p[0] = 0;
	long long summ = a[0];
	int i = 0, j = 0;
	int best_count = n;
	MinQue que;
	que.push(a[0]);
	while (i <= j && j < n) {
		if (summ  - que.get_min() < com_s * 1. / 2) {
			++j;
			if (j >= n) break;
			summ += a[j];
			que.push(a[j]);
		}
		else {
			best_count = min(best_count, j - i + 1);
			que.pop();
			summ -= a[i++];
		}
	}
	cout << best_count - 1;
}
