#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e6 + 100;
const int mod = 1e9 + 7, k1 = 29, k2 = 31;
int deg1[maxn], deg2[maxn];

int add(int a, int b) {
    if (a + b >= mod)
        return a + b - mod;
    return a + b;
}

int mul(int a, int b) {
    return (int) ((1LL * a * b) % mod);
}

int sub(int a, int b) {
    if (a - b < 0)
        return a - b + mod;
    return a - b;
}

pair<int, int> add(pair<int, int> a, pair<int, int> b) {
    return {add(a.first, b.first), add(a.second, b.second)};
}

pair<int, int> mul(pair<int, int> a, pair<int, int> b) {
    return {mul(a.first, b.first), mul(a.second, b.second)};
}

void precalc() {
    deg1[0] = deg2[0] = 1;
    for (int i = 1; i < maxn; i++) {
        deg1[i] = mul(deg1[i - 1], k1);
        deg2[i] = mul(deg2[i - 1], k2);
    }
}

vector<vector<pair<int, int>>> hashes;
int n;
bool check(int len) {
    map<pair<int, int>, int> hsh2cnt;
    for (int i = 0; i < n; i++) {
        hsh2cnt[hashes[i][len]]^=1;
    }

    bool flag = true;
    for (auto &el : hsh2cnt) {
        flag = flag && (el.second == 0);
    }

    return flag;
}

void solve() {
    cin >> n;
    vector<string> ss(n);
    int mn = 1e9;
    for (auto &el : ss) {
        cin >> el;
        mn = min(mn, (int) el.size());
    }
    hashes.resize(n);
    for (int i = 0; i < n; i++) {
        hashes[i].resize((int) ss[i].size() + 1);
        hashes[i][0] = {0, 0};
        for (int j = 0; j < (int) ss[i].size(); j++) {
            hashes[i][j + 1] = add(mul(hashes[i][j], {k1, k2}), {ss[i][j] - 'a' + 1, ss[i][j] - 'a' + 1});
        }
    }

    int l = 0, r = mn + 1;
    while (r - l > 1) {
        int mid = (r + l) >> 1;
        if (check(mid)) {
            l = mid;
        } else {
            r = mid;
        }
    }
    cout << l << '\n';
}

/*
 5
 1
 -4
 0
 -7
 239
 */

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    precalc();
    int T = 1;
    while (T--)
        solve();
    return 0;
}