#include <bits/stdc++.h>
#define int long long
using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int INF = 1e18 + 7;

struct segtree{
    int s = 1;
    vector<int> tree;

    void init(int n) {
        while (s < n) s *= 2;
        tree.assign(2 * s - 1, INF);
    }

    void set(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m)
            set(i, v, 2 * x + 1, lx, m);
        else
            set(i, v, 2 * x + 2, m, rx);
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }

    void set(int i, int v) {
        set(i, v, 0, 0, s);
    }

    int minn(int l, int r, int x, int lx, int rx) {
        if (l <= lx && rx <= r)
            return tree[x];
        if (rx <= l || r <= lx)
            return INF;
        int m = (lx + rx) / 2;
        int m1 = minn(l, r, 2 * x + 1, lx, m);
        int m2 = minn(l, r, 2 * x + 2, m, rx);
        return min(m1, m2);
    }

    int minn(int l, int r) {
        return minn(l, r, 0, 0, s);
    }
};

void solve() {
    int n, sum = 0;
    cin >> n;
    segtree t;
    t.init(n);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
    sum = (sum + 1) / 2;
    vector<int> dp(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        dp[i + 1] = dp[i] + a[i];
        t.set(i, a[i]);
    }
    int ans = INF;
    for (int i = 0; i < n; ++i) {
        int l = i, r = n;
        while (l < r) {
            int m = (l + r) / 2;
            if (dp[m] - dp[i] < sum)
                l = m + 1;
            else
                r = m;
        }
        int sum1 = dp[r] - dp[i];
        if (sum1 >= sum) {
            if (t.minn(i, r) <= sum1 - sum)
                ans = min(ans, r - i - 1);
            else
                ans = min(ans, r - i);
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--)
        solve();
    return 0;
}
