#include <bits/stdc++.h>
#define TESTS false
#define rep(i, n) for (int i=0; i<n; i++)

using namespace std;

struct Stack
{
  int *s;
  int *m;

  Stack(int &n)
  {
    s = new int[n];
    m = new int[n];
  }

  size_t sz=0;

  size_t get_size()
  {
    return sz;
  }

  void push(int &x)
  {
    s[sz] = x;

    m[sz] = !sz ? s[sz] : min(s[sz], m[sz-1]);

    sz++;
  }

  int pop()
  {
    sz--;
    return s[sz];
  }

  int get_min()
  {
    return m[sz-1];
  }

  int &operator [] (int &i)
  {
    return s[i];
  }

  ~Stack()
  {
    delete [] m;
    delete [] s;
  }
};

struct Queue
{
  Stack *s1;
  Stack *s2;
  long long sm = 0;

  Queue(int &n)
  {
    s1 = new Stack(n);
    s2 = new Stack(n);
  }

  void push(int &x)
  {
    s1->push(x);
    sm+=x;
  }

  long long sum()
  {
    return sm;
  }

  int pop()
  {
    if (!s2->get_size())
    {
      for (int i=s1->get_size()-1; i>=0; i--)
      {
        s2->push((*s1)[i]);
        s1->pop();
      }
    }
    int x = s2->pop();
    sm -= x;
    return x;
  }

  size_t get_size()
  {
    return s2->get_size() + s1->get_size();
  }

  int get_min()
  {
    if (!s2->get_size())
    {
      return s1->get_min();
    }
    else if (!s1->get_size())
    {
      return s2->get_min();
    }
    return min(s1->get_min(), s2->get_min());
  }

  ~Queue()
  {
    delete s1;
    delete s2;
  }
};

void solve()
{
  int n;cin>>n;
  int a[n];
  int s=0;
  for (int i=0; i<n; i++)
  {
    cin>>a[i];
    s+=a[i];
  }

  int req = (s+1)/2;

  int ans = n;

  int l=0, r=n;
  int m;
  while(r-l>1)
  {
    Queue q(n);
    m = (l+r)/2;

    int g=m;

    int tt=0;

    for (int i=0; i<m; i++)
    {
      q.push(a[i]);
    }

    for (int i=m; i<n; i++)
    {
      if (q.sum()>=req)
      {
        tt++;
      }
      if (q.sum()-q.get_min()>=req)
      {
        tt++;
        g = m-1;
      }
      q.pop();
      q.push(a[i]);
    }

    if (q.sum()>=req)
    {
      tt++;
    }
    if (q.sum()-q.get_min()>=req)
    {
      tt++;
      g = m-1;
    }

    if (tt>0)
    {
      r = m;
      ans=min(ans, g);
    }
    else
    {
      l = m;
    }
  }

  cout<<ans;
}

int main()
{
  ios::sync_with_stdio(0);
  cin.tie(0);

  if (TESTS)
  {
    int t;cin>>t;
    while(t--)
    {
      solve();
      cout<<'\n';
    }
    return 0;
  }

  solve();
  return 0;
}
